#!/usr/bin/perl
# version 2
# now reduce words to be reasonable
# 
# rwb Jan 2005


# the following replacements can be done in a text editor
# \;    m\n
# \n    (nothing)
# m     \n
# \)w   \nw
# \n(space)  \n
# end function\(\)\n  (nothing)

@wordIndex = ();

# pass 1: initialise word index array
open(F,"27ab1.txt");
@file = <F>;
close(F);

print "File length $#file\n";


$i=0;
$max = 1;

while( $i<= $#file) {
  @nums = $file[$i] =~ m/w(\d+)/gx;
  foreach $num (@nums) {
    if ( $num > $max ) {
      $max = $num;
    }
  }
  $i++;
}

print "Maximum word number used is  $max\n";

for( $i=1; $i<=$max; $i++ ) {
  $wordIndex[ $i ] = 0;  
}


$g1 = $max + 1;
$g2 = $g1 + 1;
$g3 = $g2 + 1;

$wordIndex[ $g1 ] = 1;
$wordIndex[ $g2 ] = 2;
$wordIndex[ $g3 ] = 3;

print "wordIndex $g1  is  $wordIndex[$g1]\n";


open(F,">27ab2.txt");
for( $i=0; $i<=$#file; $i++) {
  $line = $file[$i];
  chomp($line);
  $line =~ s/\;/\n/g;
  $line =~ s/Q\.1/w$g1/g;  # B in this case
  $line =~ s/Q\.2/w$g2/g;  # C in this case
  $line =~ s/Q\.3/w$g3/g;
  print F "$line\n";
}
close(F);



open(F,"27ab2.txt");
@file = <F>;
close(F);

$count = 0;
$wordCount = 4;

open(F,">27ab3.txt");
for( $i=0; $i<=$#file; $i++) {
  $line = $file[$i];  
  $line =~ s/^\s+//g;
  if( $line =~ /end/ ) {
    $line = "";    
  }
  
  # mults
  if( $line =~ /(\w+)\s*\:\=\s*(\w+)\s*\*\s*(\w+)/g ) {
    $line =~ /w(\d+)\s*\:\=\s*w(\d+)\s*\*\s*w(\d+)/;
    $x = $1;    
    $y = $2;    
    $z = $3;
#    print "m  $x, $y, $z\n";    
    
    foreach $index ($x, $y, $z) {
      if( $wordIndex[ $index ] eq 0 ) {
        $wordIndex[ $index ] = $wordCount;      
        $wordCount++;      
      }
    }
    #print F "m $wordIndex[ $y ] $wordIndex[ $z ] $wordIndex[ $x ]\n";
    print F "zmu z$wordIndex[ $y ] z$wordIndex[ $z ] z$wordIndex[ $x ]\n";
  }
  
  #powers
  if ( $line =~ /(\w+)\s*\:\=\s*(\w+)\^(-*\d+)/g ) {
    $line =~ /w(\d+)\s*\:\=\s*w(\d+)\^(-*\d+)/;
    $x = $1;    
    $y = $2;
    $z = $3;
#    print "p  $x, $y, $z\n";    
    foreach $index ($x, $y) {
      if( $wordIndex[ $index ] eq 0 ) {
        $wordIndex[ $index ] = $wordCount;      
        $wordCount++;      
      }
    }
    #print F "p $wordIndex[ $y ] $z $wordIndex[ $x ]\n";
    print F "zpo z$wordIndex[ $y ] $z z$wordIndex[ $x ]\n";
  }
  
  if( $line =~ /return\s*w(\d+)/g ) {
    #print F "r $wordIndex[ $1 ]\n";    
    print F "cp z$wordIndex[ $1 ] word$count\n";    
  }
  
  
  
  if ( $line =~ /word\[(\d+)\]/ ) {
    #print F "w $1\n";
  $count++;
  }
}
close(F);

#`rm mkwd_slps_1.txt`;

print "$count elements\n";
print "new max. word is $wordCount\n";
